unit ChRestrEsp_anc;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Forms, Dialogs, Controls, StdCtrls, 
  Buttons, ExtCtrls, CompCadreIma2;

type
  TDialogChxTaxon = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    SrcList: TListBox;
    DstList: TListBox;
    SrcLabel: TLabel;
    DstLabel: TLabel;
    IncludeBtn: TSpeedButton;
    IncAllBtn: TSpeedButton;
    ExcludeBtn: TSpeedButton;
    ExAllBtn: TSpeedButton;
    CadreImage21: TCadreImage2;
    ListCaractSrc: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    ListCaractDest: TListBox;
    AjoutCar: TSpeedButton;
    AjoutToutCar: TSpeedButton;
    RetireSelCar: TSpeedButton;
    RetireToutCar: TSpeedButton;
    procedure IncludeBtnClick(Sender: TObject);
    procedure ExcludeBtnClick(Sender: TObject);
    procedure IncAllBtnClick(Sender: TObject);
    procedure ExcAllBtnClick(Sender: TObject);
    procedure SrcListMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DstListMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure OKBtnClick(Sender: TObject);
    procedure AjoutCarClick(Sender: TObject);
    procedure AjoutToutCarClick(Sender: TObject);
    procedure RetireSelCarClick(Sender: TObject);
    procedure RetireToutCarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure MoveSelected(List: TCustomListBox; Items: TStrings);
    procedure SetItem(List: TListBox; Index: Integer);
    function GetFirstSelection(List: TCustomListBox): Integer;
    procedure SetButtons;
    Procedure initialise;
  end;

var
  DialogChxTaxon: TDialogChxTaxon;

implementation

{$R *.dfm}
uses Donnees,PhylPlch;

procedure TDialogChxTaxon.IncludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(SrcList);
  MoveSelected(SrcList, DstList.Items);
  SetItem(SrcList, Index);
end;

procedure TDialogChxTaxon.ExcludeBtnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(DstList);
  MoveSelected(DstList, SrcList.Items);
  SetItem(DstList, Index);
end;

procedure TDialogChxTaxon.IncAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to SrcList.Items.Count - 1 do
    DstList.Items.AddObject(SrcList.Items[I],
      SrcList.Items.Objects[I]);
  SrcList.Items.Clear;
  SetItem(SrcList, 0);
end;

procedure TDialogChxTaxon.ExcAllBtnClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to DstList.Items.Count - 1 do
    SrcList.Items.AddObject(DstList.Items[I], DstList.Items.Objects[I]);
  DstList.Items.Clear;
  SetItem(DstList, 0);
end;

procedure TDialogChxTaxon.MoveSelected(List: TCustomListBox; Items: TStrings);
var
  I: Integer;
begin
  for I := List.Items.Count - 1 downto 0 do
    if List.Selected[I] then
    begin
      Items.AddObject(List.Items[I], List.Items.Objects[I]);
      List.Items.Delete(I);
    end;
end;

procedure TDialogChxTaxon.SetButtons;
var
  SrcEmpty, DstEmpty: Boolean;
begin
  SrcEmpty := SrcList.Items.Count = 0;
  DstEmpty := DstList.Items.Count = 0;
  IncludeBtn.Enabled := not SrcEmpty;
  IncAllBtn.Enabled := not SrcEmpty;
  ExcludeBtn.Enabled := not DstEmpty;
  ExAllBtn.Enabled := not DstEmpty;
end;

function TDialogChxTaxon.GetFirstSelection(List: TCustomListBox): Integer;
begin
  for Result := 0 to List.Items.Count - 1 do
    if List.Selected[Result] then Exit;
  Result := LB_ERR;
end;

procedure TDialogChxTaxon.SetItem(List: TListBox; Index: Integer);
var
  MaxIndex: Integer;
begin
  with List do
  begin
    SetFocus;
    MaxIndex := List.Items.Count - 1;
    if Index = LB_ERR then Index := 0
    else if Index > MaxIndex then Index := MaxIndex;
    Selected[Index] := True;
  end;
  SetButtons;
end;

procedure TDialogChxTaxon.Initialise;
Var
  i,n:integer;
  Nom:string;
begin
  //DstList.Clear; Dans la procedure d'appel remplir DstList par les items slectionns.
  For i:=0 to Taxons.NbTaxons-1 do
    begin
      Nom:=Taxons.GetNom(i);
      if DstList.Items.IndexOf(Nom)=-1 then SrcList.Items.Add(Nom);
    end;
  if SrcList.Count>0 then
    begin
      n:=Taxons.GetNumTaxon(SrcList.Items[0]);
      CadreImage21.Affiche(Taxons.GetIcone(n),Taxons.GetNom(n));
    end;
end;

procedure TDialogChxTaxon.SrcListMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var
  n,nt:integer;
  PosItem:Tpoint;
begin
  PosItem.X:=X;
  PosItem.Y:=Y;
  n:=SrcList.ItemAtPos(PosItem,true);
  if n>-1 then
    begin
      nt:=Taxons.GetNumTaxon(SrcList.Items[n]);
      CadreImage21.Affiche(Taxons.GetIcone(nt),Taxons.GetNom(nt));
    end;
end;

procedure TDialogChxTaxon.DstListMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var
  n,nt:integer;
  PosItem:Tpoint;
begin
  PosItem.X:=X;
  PosItem.Y:=Y;
  n:=DstList.ItemAtPos(PosItem,true);
  if n>-1 then
    begin
      nt:=Taxons.GetNumTaxon(DstList.Items[n]);
      CadreImage21.Affiche(Taxons.GetIcone(nt),Taxons.GetNom(nt));
    end;
end;

procedure TDialogChxTaxon.OKBtnClick(Sender: TObject);
begin
  if (DstList.Count<4) then   // or (ListCaractDest.Count<4)
    begin
      MessageDlg('Il faut slectionner au moins 4 taxons',mtError,[mbOK],0); // et 4 caractres
      ModalResult:=mrNone;
    end
  else
    begin
      ModalResult:=mrOK;
    end;
end;

procedure TDialogChxTaxon.AjoutCarClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(ListCaractSrc);
  MoveSelected(ListCaractSrc,ListCaractDest.Items);
  SetItem(ListCaractSrc, Index);
end;

procedure TDialogChxTaxon.AjoutToutCarClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to ListCaractSrc.Items.Count - 1 do
    ListCaractDest.Items.AddObject(ListCaractSrc.Items[I],
      ListCaractSrc.Items.Objects[I]);
  ListCaractSrc.Items.Clear;
  SetItem(ListCaractSrc, 0);
end;

procedure TDialogChxTaxon.RetireSelCarClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := GetFirstSelection(ListCaractDest);
  MoveSelected(ListCaractDest,ListCaractSrc.Items);
  SetItem(ListCaractDest, Index);
end;

procedure TDialogChxTaxon.RetireToutCarClick(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to ListCaractDest.Items.Count - 1 do
    ListCaractSrc.Items.AddObject(ListCaractDest.Items[I],ListCaractDest.Items.Objects[I]);
  ListCaractDest.Items.Clear;
  SetItem(ListCaractDest, 0);
end;

end.
