unit FenEtatcarac;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, MyNewgrid, Menus, ExtCtrls;

type
  TFicheEtatCarac = class(TForm)
    CaracGrid1: TTabGrid;
    MainMenu1: TMainMenu;
    Fermer1: TMenuItem;
    Panel1: TPanel;
    PaintBox: TPaintBox;
    Copier1: TMenuItem;
    commeimage1: TMenuItem;
    commetexte1: TMenuItem;
    Imprimer: TMenuItem;
    procedure Fermer1Click(Sender: TObject);
    procedure PaintBoxPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CopierImprimerClick(Sender: TObject);
    procedure commetexte1Click(Sender: TObject);
  private
    { Dclarations prives}
  public
    { Dclarations publiques}
    ColorerDerive:boolean;
    CouleurDerive:TColor;
    CouleurAncestraux:TColor;
    ModDerive,ModAncestral,Desactive:TAffichCell;
    Derives:Array of Boolean;
    Ancestraux:Array of Boolean;
    procedure initialise;
  end;

var
  FicheEtatCarac: TFicheEtatCarac;

implementation
uses donnees,PhylBig,gestimpr,clipbrd;
{$R *.DFM}

procedure TFicheEtatCarac.Fermer1Click(Sender: TObject);
begin
  ModalResult:=mrOK;
end;

procedure TFicheEtatCarac.PaintBoxPaint(Sender: TObject);
begin
  with PaintBox.Canvas do
    begin
      Brush.Style:=bsSolid;
      Brush.Color:=CouleurAncetreClique;
      Pen.Color:=ClBlack;
      Ellipse(4,4,14,14);
   end;
end;
procedure TFicheEtatCarac.initialise;
Var
  i:integer;
begin
  ModDerive.CouleurFond:=CouleurDerive;
  ModAncestral.CouleurFond:=CouleurAncestraux;
  if ColorerDerive then
    begin
      for i:=0 to CaracGrid1.RowCount-1 do
        begin
          if Derives[i] then CaracGrid1.AffichCell[1,i]:=ModDerive
          else if Ancestraux[i] then CaracGrid1.AffichCell[1,i]:=ModAncestral
          else CaracGrid1.AffichCell[1,i]:=Desactive;
        end;
    end;
end;
procedure TFicheEtatCarac.FormCreate(Sender: TObject);
begin
  CouleurDerive:=ClYellow; //par dfaut
  CouleurAncestraux:=ClBlue;
  ModDerive.Active:=True;
  ModDerive.CouleurFond:=CouleurDerive;
  ModDerive.CouleurTexte:=clBlack;
  ModDerive.styleFond:=bsSolid;
  ModDerive.CouleurContour:=clBlack;
  ModAncestral:=ModDerive;
  ModAncestral.CouleurFond:=CouleurAncestraux;
  ModAncestral.CouleurTexte:=clWhite;
  Desactive.Active:=false;
end;

procedure TFicheEtatCarac.CopierImprimerClick(Sender: TObject);
Var
  BitmapCopie:TBitmap;
  n:integer;
begin
  n:=(Sender as TMenuItem).tag;
  BitmapCopie:=TBitmap.Create;
  CaracGrid1.DessineTableau(BitmapCopie);
  If FormBig=nil then FormBig:=TFormBig.Create(Application);
  FormBig.ImgBig.Bitmap.Assign(BitmapCopie);
  BitmapCopie.Free;
  if FormBig.ShowModal=mrOK then
    begin
      if n=1 then
        begin
          Gestimp.Bitmap32.Assign(FormBig.ImageRetour);
          Gestimp.ShowModal;
        end
      else Clipboard.Assign(FormBig.ImageRetour);
    end;
end;

procedure TFicheEtatCarac.commetexte1Click(Sender: TObject);
Var
  Tableau:TMyCustomGrid;
  i,j:integer;
  Chaine:string;
  ChaineTableau:TStringList;
  ZeroTerminal:PChar;
  CarSautCol:string;
begin
  CarSautCol:=#9;
  Tableau:=CaracGrid1;
  ChaineTableau:=TStringList.Create;
  ChaineTableau.Clear;
  //if Titre<>'' then ChaineTableau.Add(Titre);
  for i:=0 to Tableau.RowCount - 1 do
    begin
      Chaine:=Tableau.Cells[0,i];
      for j:=1 to Tableau.ColCount - 1 do
        begin
          chaine:=chaine+CarSautCol+Tableau.Cells[j,i];
        end;
      ChaineTableau.Add(chaine);
    end;
  ZeroTerminal:=ChaineTableau.GetText;
  ClipBoard.SetTextBuf(ZeroTerminal);
  ChaineTableau.Free;
end;

end.
